#!/usr/bin/env python

import find
from requires import file_requires
from provides import file_provides

def check(path) :
    req = {}
    for x,y in file_requires((x.path for x in find.find(path,lambda x : x.isreg() and x.check_regex(".*.py$")))) :
        req.setdefault(x,[]).append(y)            

    sreq = set(req.keys())

    sprov = set(( x for x,y in
        file_provides(
            [x.path for x in find.find(path,lambda x : x.isreg() and x.check_regex(".*.py$"))]
        )
    ))     

    for item in sreq-sprov :
        print item,":"
        for file in req[item] :
            print "\t",file
        print ""
    
if __name__ == '__main__' :
    import sys
    for item in sys.argv[1:] :
        check(item)
    
    
